function LinearCongruentialGenerator(seed) {
	if ( !(this instanceof arguments.callee) ) {
		return new arguments.callee(seed);
	}

	var that = this,
		// glibc values https://en.wikipedia.org/wiki/Linear_congruential_generator
		m = 4294967296, // modulus 2^32
		a = 1103515245, // multiplier
		c = 12345, // increment
		x = Number(seed);

	function generate() { x = (a * x + c) % m; }

	this.next = function () {
		generate();
		return (x / m);
	};
}
