const contextMenu = require("context-menu"),
	panel = require("panel"),
//	passwd = require("passwords"),
	data = require("self").data,
	{Cc, Ci} = require("chrome"),
	eTLDSvc = Cc["@mozilla.org/network/effective-tld-service;1"]
		.getService(Ci.nsIEffectiveTLDService);

exports.main = function (options, callbacks) {
	function getGeneratorContent(menuData) {
		var actionUrl = menuData.formAction || menuData.locationHref;
		return {
			domainKey: eTLDSvc.getBaseDomainFromHost(actionUrl.split("/")[2]),
			masterKey: menuData.passwordFieldValue,
			reqLength: (menuData.passwordFieldMaxLen > 8 && menuData.passwordFieldMaxLen < 48) ? menuData.passwordFieldMaxLen : 48,
			savedUrl: menuData.locationHref.split("/").slice(0,3).join("/"),
			savedFormUrl: actionUrl.split("/").slice(0,3).join("/"),
			savedUsrField: menuData.usernameFieldName,
			savedPwField: menuData.passwordFieldName,
			savedUsername: menuData.usernameFieldValue
		};
	}

	var generatorPanel = panel.Panel({
		width: 600,
		height: 480,
		contentURL: data.url("generator.html"),
		contentScriptFile: [
			data.url('generator.js'),
			data.url('sha256.js'),
			data.url('linear-congruential-generator.js')
		],
		onShow: function () {
			this.postMessage(this.content);
		}
	}),

		menuItem = contextMenu.Item({
		label: "Generate Password",
		context: contextMenu.SelectorContext("input[type=password]"),
		contentScriptFile: data.url('context-menu.js'),
		onMessage: function(data) {
			generatorPanel.content = getGeneratorContent(data);
			console.log(generatorPanel.content.toSource());
			generatorPanel.show();
		}
	});

	generatorPanel.port.on('hide', function () {
		generatorPanel.hide();
	});

};

console.log("The add-on is running.");
